<?php
/*	=====================================================
	lib_setuphelper, Version 1.04.000
	=====================================================

$module_directory     = 'lib_setuphelper';
$module_name          = 'Setup helping library';
$module_function      = 'library';
$module_version       = '1.04.000';
$module_platform      = '2.x';
$module_author        = 'Wolfgang Studer';
$module_license       = 'GNU General Public License';
$module_license_terms = '-';
$module_description   = 'Library providing support on creating SQLs during INSTALL, UPGRADE and UNINSTALL';
$module_guid          = '75de805b-6ee3-47df-91bc-c5746bee12ad';
$module_home          = 'www.wolfgangstuder.ch | www.lepton-cms.com';
$lepador_link         = 'http://www.lepton-cms.com/lepador/library/lib_setuphelper.php';
$forum_link           = 'http://forum.lepton-cms.org/viewtopic.php?f=66&t=3049';

=====================================================

INTRO
==================================

Ein Bibliotheks-Modul für das LEPTON CMS.

Dieses Modul unterstützt das Erstellen von SQL im INSTALL, UPGRADE, UNINSTALL, ADD
und DELETE Prozess.
Speziell im INSTALL und UPGRADE Prozess bietet es unterstützung für ALTER Table
Funktionalitäten sowie die Bereinigung des Modulverzeichnisses auf dem Filesystem.

Dieses Modul unterstützt das Modul "lib_logger" und kann damit verschiedene
Fehler, Aktivitäten und SQLs in einer Datenbank Tabelle speichern und im Modul
"logger" anzeigen.
Die Module "lib_logger" und "logger" sind optional und für den
Betrieb dieses Modules nicht zwingend.

Dieses Modul unterstützt das Modul "lib_dependency" zur Sicherstellung von
Abhängigkeiten während einer De-Installation.
Das Modul "lib_dependency" ist optional und für den Betrieb dieses Modules nicht
zwingend.
Das Modul kann auch nachträglich installiert werden, vorhandene Abhängigkeiten
werden semi-automatisch eingetragen (register_dependency.php).
Siehe auch die README.de.txt Datei von "lib_dependency" für weitere Informationen.

PRE-REQUIREMENTS
==================================
>=       2.2 : LEPTON_VERSION
>=       5.6 : PHP_VERSION
>=  0.03.001 : WB_ADDONS[ 'lib_dependency' ] (optional)
>=  0.05.002 : WB_ADDONS[ 'lib_logger' ] (optional)

INSTALLATION
==================================

1. Lade die letzte Version von
	http://www.lepton-cms.com/lepador/modules/lib_setuphelper.php
2. Melde dich im Lepton CMS Backend an
3. Gehe zu Erweiterungen -> Module
4. Im Block "Modul installieren", wähle die im Schritt 1 heruntergeladene
	lib_setuphelper ZIP Datei, dann klicke auf den "Installieren" Button.


DE-INSTALLATION
==================================

1. Melde dich im Lepton CMS Backend an
2. Gehe zu Erweiterungen -> Module
3. Im Block "Modul deinstallieren", wähle das Modul "lib_setuphelper",
	dann klicke auf den "Deinstallieren" Button.

BENUTZUNG VON lib_setuphelper
==================================

Dieses Bibliotheks-Modul kann in folgenden Dateien verwendet werden:
- install.php
- upgrade.php
- uninstall.php
- add.php
- delete.php

Der Inhalt dieser Dateien besteht - nach dem Security Teil - aus einem einheitlichen
Quellcode ( Die Kommentare darin dienen nur zur Dokumentation und können entfernt werden ).
Beispielsdateien finden sich im Verzeichnis "examples" in diesem
Bibliotheks-Modul und können entsprechend adaptiert werden.


Zusätzlich wird eine Datei "_setup.php" im Root-Verzeichnis des Modules benötigt.
Diese "_setup.php" Datei steuert die Definition der Datenbank Tabellen und die dazugehörigen
Aktionen.
Eine Beispielsdatei von "_setup.php" findet sich im Verzeichnis "examples" in diesem
Bibliotheks-Modul und muss entsprechend adaptiert werden.


Ist das Bibliotheks-Modul "lib_logger" installiert, kann der Logging Level
definiert werden:
			// 0 = no logging
			// 1 = errors
			// 4 = infos
			// 5 = errors & infos
			// 8 = notice
			// 9 = errors & notice
			// 12 = infos & notice
			// 13 = all

Es sind folgende "errors", "infos" und "notice" Meldungen möglich:
- LOG		= Start and End of logging entries. Can not be switched ON/OFF.

- ERROR		= passed trigger is unknow. Allowed triggers are INSTALL, UPGRADE, UNINSTALL, ADD, DELETE.
- ERROR		= passed setup array is empty.
- ERROR		= no field definition in setup array. Occurs during INSTALL, UPGRADE only.
- ERROR		= key 'Field' in fieldset passed in setup array is missing. Occurs during INSTALL, UPGRADE only.
- ERROR		= key 'Type' in fieldset passed in setup array is missing. Occurs during INSTALL, UPGRADE only.
- ERROR		= creation of SHOW CREATE TABLE for temp table during alter table process failed. Occurs during INSTALL, UPGRADE only.
- ERROR		= creation of SHOW CREATE TABLE for existing table during alter table process failed. Occurs during INSTALL, UPGRADE only.
- ERROR		= passed module path does not exists. Occurs only if module folder cleanup is requested.
- ERROR		= archive folder for module folder cleanup could not be created.
- ERROR		= file could not be moved into archive folder during module folder cleanup.
- ERROR		= generic error ocured during SQL execution.

- NOTICE	= no action for current trigger.
- NOTICE	= about if create or alter table process is done. Occurs during INSTALL, UPGRADE only.
- NOTICE	= alter table functionality has been switched off. Occurs during INSTALL, UPGRADE only.
- NOTICE	= no module folder cleanup requested.

- INFO		= SHOW CREATE TABLE content for temp table in alter table process. Occurs during INSTALL, UPGRADE only.
- INFO		= SHOW CREATE TABLE content for existing table in alter table process. Occurs during INSTALL, UPGRADE only.
- INFO		= list of files moved into archive during module folder cleanup.
- INFO		= list of path items where master_index.php has been set/overwritten.
- INFO		= Missing mandatory information when building queries. No error, but query is not beeing executed.
- INFO		= executed query.

#@INCLUDE: README_DE_OPTIONIZER#

#@INCLUDE: README_DE_DEPENDENCY#

EIGENE ERWEITERUNGEN
===========================

Dieses Modul wurde so entwickelt, das es durch den System-Administrator an verschiedenen
Punkten erweitert werden kann, ohne im Modul selbst Aenderungen vorzunehmen und dadurch
die Aenderungen bei einem allfälligen Update zu verlieren.
Hier nachfolgend die Punkte und Dateien:

Benutze Variablen:
- {LEPTON_PATH}   = der LEPTON CMS Installations Pfad
- {DEFAULT_THEME} = das verwendete Backend Theme
- {TEMPLATE}      = das verwendete Frontend Template
- {COMPONENT}     = der Komponenten Name, z.B. "modify_optionizer"
- {LANGUAGE}      = der momentan verwendete Sprachcode, in Grossbuchstaben

- {BACKEND_PATH}  = {LEPTON_PATH}/templates/{DEFAULT_THEME}/backend/lib_setuphelper
- {FRONTEND_PATH} = {LEPTON_PATH}/templates/{TEMPLATE}/frontend/lib_setuphelper


Für das Backend:
- {BACKEND_PATH}/backend.css
	>> hier kann das verwendete Standard Style überschrieben werden.
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!

- {BACKEND_PATH}/languages/{LANGUAGE}.php
	>> hier kann der verwendete Standard Text überschrieben werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.backend.config.{COMPONENT}.php
	>> In dieser Datei können Standard Konfigurations Werte überschrieben werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> diese Datei wird ausgeführt, nachdem das SQL ausgeführt wurde. Benutze diese Datei
		wenn Daten manipuliert werden sollen, bevor diese an die TWIG Engine übergeben
		werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> Benutze diese Datei, wenn zusätzliche Variablen im TWIG Template verwendet werden
		sollen.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/templates/backend/{COMPONENT}.lte
	>> mit dieser Datei kann das Standard Template ersetzt werden.
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!
	Wichtig: Es kann auch ein Template  mit einem anderen Namen verwendet werden.
	Dazu muss in: {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	folgendes definiert werden:
		// define twig template
		$twigTemplate =  '<<dein Template Name>>';

#@INCLUDE: README_DE_ENHANCEMENT_MOD#



WEITERE DOKUMENTATION
===========================

Weitere Informationen zu diesem Modul findet sich im LEPTON CMS Forum
http://forum.lepton-cms.org/index.php

!! Beachtet bitte das das Forum nur in englischer Sprache geführt wird !!


Enjoy!
*/
?>
