<?php

/**  // € // to identify files as UTF8
 * Library providing support on creating SQLs during INSTALL, UPGRADE and UNINSTALL
 *
 * @module          lib_setuphelper
 * @author          Wolfgang Studer
 * @copyright       2016 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.04.000 | 2016-12-07
 * @lepador_link    http://www.lepton-cms.com/lepador/library/lib_setuphelper.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3049
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/** ------------------------------------------------------------------------------------
 * get list of last modified files
 *
 * @param	string		$path
 * @return	array		list of items found
 ** ------------------------------------------------------------------------------------
 */
if ( function_exists( 'dbs_get_last_file_list' ) == FALSE ):
	function dbs_get_last_file_list( $path = '-1' )
	{
		if ( is_dir( $path ) == TRUE ):

			// take info.php timestamp and subtract 2 minutes
			if ( file_exists( $path . '/info.php' ) == TRUE ):
				$base = filemtime( $path . '/info.php' );
			else:
				$base = time();
			endif;
			$start = $base - 120;	// minus 2 minutes

			// loop over input path items (files & folders) and return list of all items
			// having modification date >= $start
			$path = realpath( $path );
			$dir  = new RecursiveDirectoryIterator( $path, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS );
			$files = new RecursiveIteratorIterator( $dir, RecursiveIteratorIterator::SELF_FIRST );
			$items = array();
			$i = 0;
			while( $files->valid() ):
				if ( $files->getMTime() >= $start ):
					$items[$i++] = $files->getPathname();
				endif;
				$files->next();
			endwhile;
		endif;

		// return
		return $items;
	}
endif;

?>
