<?php

/**  // € // to identify files as UTF8
 * Library providing support on creating SQLs during INSTALL, UPGRADE and UNINSTALL
 *
 * @module          lib_setuphelper
 * @author          Wolfgang Studer
 * @copyright       2016 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.04.000 | 2016-12-07
 * @lepador_link    http://www.lepton-cms.com/lepador/library/lib_setuphelper.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3049
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// set $module as current module
	$dbs_module = 'lib_setuphelper';

// set processing initials
	$dbs_component = basename( __FILE__, '.php' );
	$dbs_modulePath = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;
	$includes = array();

// include the basic files at start
	// setup module initials
	$includes[]	= array( 'LOADER'=> 'require', 'FILE' => $dbs_modulePath . 'register_initial.php' );
	include( $dbs_modulePath . 'load_includes.php' );

	// include language registration
	$includes[]	= $dbs_modulePath . 'register_language.php';
	// include backend config files
	$includes[]	= $dbs_modulePath . 'lib/lib.config.php';
	$includes[]	= $dbs_modulePath . 'lib/lib.backend.config.php';
	$includes[]	= $dbs_templatePath . 'lib/lib.backend.config.php';
	$includes[]	= $dbs_modulePath . 'lib/lib.backend.config.' . $dbs_component . '.php';
	$includes[]	= $dbs_templatePath . 'lib/lib.backend.config.' . $dbs_component . '.php';
	// include basic functions
	$includes[]	= $dbs_modulePath . 'lib/lib.backend.functions.php';
	// do include
	include( $dbs_modulePath . 'load_includes.php' );

// included needed classes
	$includes[]	= array( 'LOADER'=> 'require', 'FILE' => $dbs_modulePath . 'classes/class.setup.php' );
	if (( isset( $logging )	== TRUE )
	and ( $logging			!= '0'  )):
		$includes[]	= LEPTON_PATH . '/modules/lib_logger/library.php';
	endif;
	include( $dbs_modulePath . 'load_includes.php' );

// create new class instance
	if ( class_exists( 'DB_setup' ) == TRUE ):
		$DB_setup = new DB_setup( $database );

		// load initial data into class
		$DB_setup->setOptions( 'LOGTEXT', $MOD_LIB_SETUPHELPER );

		if (( isset( $logging )		== TRUE )
		and ( $logging				!= '0'  )
		and ( isset( $logger )		== TRUE )
		and ( $logger instanceof DB_logger  )):
			$DB_setup->setLogger( $logger, $logging );
		else:
			$DB_setup->setLogger();
		endif;
	endif;

?>
