<?php

/**  // € // to identify files as UTF8
 * Library providing support on creating SQLs during INSTALL, UPGRADE and UNINSTALL
 *
 * @module          lib_setuphelper
 * @author          Wolfgang Studer
 * @copyright       2016 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.04.000 | 2016-12-07
 * @lepador_link    http://www.lepton-cms.com/lepador/library/lib_setuphelper.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3049
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// define langauge array
	$languages = array();
	if ( isset( $dbs_modulePath ) == TRUE ):
		$languages[] = array( 'language' => LANGUAGE
							, 'fallback' => 'EN'
							, 'path'     => $dbs_modulePath . DIRECTORY_SEPARATOR . 'languages' . DIRECTORY_SEPARATOR
							);
	endif;
	if ( isset( $dbs_templatePath ) == TRUE ):
		$languages[] = array( 'language' => LANGUAGE
							, 'fallback' => 'EN'
							, 'path'     => $dbs_templatePath . DIRECTORY_SEPARATOR . 'languages' . DIRECTORY_SEPARATOR
							);
	endif;


// load language files
	foreach ( $languages as $language ):
		// first generic
		$languageFile = $language['path'] . $language['language'] . '.php';
		if (( file_exists( $languageFile ) == FALSE )
		AND ( $language['language'] != $language['fallback'] )):
			$languageFile = $language['path'] . $language['fallback'] . '.php';
		endif;
		if ( file_exists( $languageFile ) == TRUE ):
			require_once( $languageFile );
		endif;

		// then component specific
		$languageFile = $language['path'] . $language['language'] . '.' . $dbs_component . '.php';
		if (( file_exists( $languageFile ) == FALSE )
		AND ( $language['language'] != $language['fallback'] )):
			$languageFile = $language['path'] . $language['fallback'] . '.' . $dbs_component . '.php';
		endif;
		if ( file_exists( $languageFile ) == TRUE ):
			require_once( $languageFile );
		endif;

		// then additional component specific
		// the additional component can be used to load the language file from another component
		if ( isset( $dbs_componentLang ) == TRUE ):
			$languageFile = $language['path'] . $language['language'] . '.' . $dbs_componentLang . '.php';
			if (( file_exists( $languageFile ) == FALSE )
			AND ( $language['language'] != $language['fallback'] )):
				$languageFile = $language['path'] . $language['fallback'] . '.' . $dbs_componentLang . '.php';
			endif;
			if ( file_exists( $languageFile ) == TRUE ):
				require_once( $languageFile );
			endif;
		endif;
	endforeach;

?>
